      PROGRAM HOST07
C
C     PROBLEM 07
C
C  REFERENCE:  PROBLEMS TO TEST PARALLEL AND VECTOR LANGUAGES
C              CSD-TR 516, COMPUTER SCIENCE, PURDUE UNIVERSITY
C              JOHN R. RICE, MAY 1, 1985
C
C              REVISED BY JOHN R. RICE AND J. JING, OCT. 1, 1990
C
C
C      *************************************************
C      *      Adapted for FORTRAN D benchmarking       *
C      *    by  T. HAUPT  (haupt@sccs.npac.syr.edu)    *
C      *                                               *
C      *    Northeast Parallel Architectures Center    *
C      *   at Syracuse University, Syracuse, NY, USA   *
C      *************************************************
C
C
C       VERSION MIMD/iPSC860-1.00-HOST   (F77+mp)
C       ==================================================
C
      INCLUDE 'picl_def.h'
      INTEGER KASES,NK,MK
      PARAMETER (KASES=3)
      INTEGER N(KASES),M(KASES)
      DATA N /3,5,10/
      DATA M /2048,16384,32768/
      REAL P(4)
      DOUBLE PRECISION HOST_SEC, NODE_SEC, STARTTIME
      INTEGER*4 TIMESIZE, TIMETYPE
      DATA TIMESIZE,TIMETYPE /8,10/
      INTEGER*4 ME,HOST,ALLNODES
      INTEGER*4 NPROCS,TOP,ORD,DIR
      INTEGER*4 INITTYPE
      DATA INITTYPE /1/
      DATA TOP,ORD,DIR,ALLNODES /1,1,1,-1/
C -----------------------------------------------------------
C           parameters of the initial broadcast
C -----------------------------------------------------------
      INTEGER*4 MSG(2),MSGSIZE
      DATA MSGSIZE /8/
      EQUIVALENCE (MSG(1),NK),(MSG(2),MK)
C -----------------------------------------------------------
C      parameters of messages with partial results
C -----------------------------------------------------------
      INTEGER*4 TYPE2,TYPE1
      DATA TYPE1,TYPE2 /20,21/
C

      WRITE(6,*) 'enter the number of processors'
      READ(5,*) NPROCS
      CALL open0(NPROCS,ME,HOST)
      CALL load0("node07",ALLNODES)
      CALL setarc0(NPROCS, TOP, ORD, DIR)


      DO 50 K =  1, KASES

      NK=N(K)
      DO 40 I = 1, KASES

      STARTTIME=clock0()
      DO MANY=1,50
      MK=M(I)
         CALL bcast0(MSG,MSGSIZE,INITTYPE,HOST)
         CALL recv0(P(1),8,TYPE1)
         CALL recv0(P(3),8,TYPE2)
      ENDDO
      HOST_SEC=clock0()-STARTTIME

      CALL recv0(NODE_SEC,TIMESIZE,TIMETYPE)

      PRINT *,'PROBLEM 7 WITH N,M =',NK,MK
         WRITE (6,*) 'GIVES P(',P(1),')  =',P(2)
         WRITE (6,*) 'AND   P(',P(3),')  =',P(4)

      PRINT *, 'TIME ON NODE 0 =',NODE_SEC,' SECONDS'
      PRINT *, 'TIME ON HOST 0 =',HOST_SEC,' SECONDS'

   40 CONTINUE
   50 CONTINUE
C     stop processes on nodes
C
      NK=-1
      CALL bcast0(MSG,MSGSIZE,INITTYPE,HOST)
      CALL close0(1)
      STOP
      END








